package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * ModelUpgradeSiteInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class ModelUpgradeSiteInfo   {
  @JsonProperty("currentPage")
  private Integer currentPage;

  @JsonProperty("currentPageSize")
  private Integer currentPageSize;

  @JsonProperty("totalRows")
  private Integer totalRows;

  @JsonProperty("allSiteIds")
  @Valid
  private List<String> allSiteIds = null;

  @JsonProperty("data")
  @Valid
  private List<SiteBasicInfo> data = null;

  public ModelUpgradeSiteInfo currentPage(Integer currentPage) {
    this.currentPage = currentPage;
    return this;
  }

  /**
   * Start page number. Start from 1.
   * @return currentPage
  */
  @ApiModelProperty(value = "Start page number. Start from 1.")


  public Integer getCurrentPage() {
    return currentPage;
  }

  public void setCurrentPage(Integer currentPage) {
    this.currentPage = currentPage;
  }

  public ModelUpgradeSiteInfo currentPageSize(Integer currentPageSize) {
    this.currentPageSize = currentPageSize;
    return this;
  }

  /**
   * Number of entries per page. It should be within the range of 1–100.
   * @return currentPageSize
  */
  @ApiModelProperty(value = "Number of entries per page. It should be within the range of 1–100.")


  public Integer getCurrentPageSize() {
    return currentPageSize;
  }

  public void setCurrentPageSize(Integer currentPageSize) {
    this.currentPageSize = currentPageSize;
  }

  public ModelUpgradeSiteInfo totalRows(Integer totalRows) {
    this.totalRows = totalRows;
    return this;
  }

  /**
   * Total rows.
   * @return totalRows
  */
  @ApiModelProperty(value = "Total rows.")


  public Integer getTotalRows() {
    return totalRows;
  }

  public void setTotalRows(Integer totalRows) {
    this.totalRows = totalRows;
  }

  public ModelUpgradeSiteInfo allSiteIds(List<String> allSiteIds) {
    this.allSiteIds = allSiteIds;
    return this;
  }

  public ModelUpgradeSiteInfo addAllSiteIdsItem(String allSiteIdsItem) {
    if (this.allSiteIds == null) {
      this.allSiteIds = new ArrayList<>();
    }
    this.allSiteIds.add(allSiteIdsItem);
    return this;
  }

  /**
   * All siteIDs in the query result.
   * @return allSiteIds
  */
  @ApiModelProperty(value = "All siteIDs in the query result.")


  public List<String> getAllSiteIds() {
    return allSiteIds;
  }

  public void setAllSiteIds(List<String> allSiteIds) {
    this.allSiteIds = allSiteIds;
  }

  public ModelUpgradeSiteInfo data(List<SiteBasicInfo> data) {
    this.data = data;
    return this;
  }

  public ModelUpgradeSiteInfo addDataItem(SiteBasicInfo dataItem) {
    if (this.data == null) {
      this.data = new ArrayList<>();
    }
    this.data.add(dataItem);
    return this;
  }

  /**
   * Site basic information on one page.
   * @return data
  */
  @ApiModelProperty(value = "Site basic information on one page.")

  @Valid

  public List<SiteBasicInfo> getData() {
    return data;
  }

  public void setData(List<SiteBasicInfo> data) {
    this.data = data;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelUpgradeSiteInfo modelUpgradeSiteInfo = (ModelUpgradeSiteInfo) o;
    return Objects.equals(this.currentPage, modelUpgradeSiteInfo.currentPage) &&
        Objects.equals(this.currentPageSize, modelUpgradeSiteInfo.currentPageSize) &&
        Objects.equals(this.totalRows, modelUpgradeSiteInfo.totalRows) &&
        Objects.equals(this.allSiteIds, modelUpgradeSiteInfo.allSiteIds) &&
        Objects.equals(this.data, modelUpgradeSiteInfo.data);
  }

  @Override
  public int hashCode() {
    return Objects.hash(currentPage, currentPageSize, totalRows, allSiteIds, data);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelUpgradeSiteInfo {\n");
    
    sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
    sb.append("    currentPageSize: ").append(toIndentedString(currentPageSize)).append("\n");
    sb.append("    totalRows: ").append(toIndentedString(totalRows)).append("\n");
    sb.append("    allSiteIds: ").append(toIndentedString(allSiteIds)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

